Index: smf/Sources/ManageRegistration.php
===================================================================
--- smf/Sources/ManageRegistration.php	(revision 1047)
+++ smf/Sources/ManageRegistration.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.2                                           *
+* Software Version:           SMF 1.1.10                                          *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -159,7 +159,7 @@
 			'check_reserved_name' => true,
 			'check_password_strength' => false,
 			'check_email_ban' => false,
-			'send_welcome_email' => isset($_POST['emailPassword']),
+			'send_welcome_email' => isset($_POST['emailPassword']) || empty($_POST['password']),
 			'require' => isset($_POST['emailActivate']) ? 'activation' : 'nothing',
 			'memberGroup' => empty($_POST['group']) ? 0 : (int) $_POST['group'],
 		);
@@ -301,7 +301,7 @@
 
 	// Generate a sample registration image.
 	$context['use_graphic_library'] = in_array('gd', get_loaded_extensions());
-	$context['verificiation_image_href'] = $scripturl . '?action=verificationcode;rand=' . md5(rand());
+	$context['verificiation_image_href'] = $scripturl . '?action=verificationcode;rand=' . md5(mt_rand());
 
 	$character_range = array_merge(range('A', 'H'), array('K', 'M', 'N', 'P'), range('R', 'Z'));
 	$_SESSION['visual_verification_code'] = '';
Index: smf/Sources/PackageGet.php
===================================================================
--- smf/Sources/PackageGet.php	(revision 1047)
+++ smf/Sources/PackageGet.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1                                             *
+* Software Version:           SMF 1.1.9                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -250,6 +250,18 @@
 
 		// Clear any "relative" URL.  Since "server" is not present, "relative" is garbage.
 		unset($_GET['relative']);
+		
+		$token = checkConfirm('get_absolute_url');
+		if ($token !== true)
+		{
+			$context['sub_template'] = 'package_confirm';
+		
+			$context['page_title'] = $txt['smf183'];
+			$context['confirm_message'] = sprintf($txt['package_confirm_view_package_content'], htmlspecialchars($_GET['absolute']));
+			$context['proceed_href'] = $scripturl . '?action=packageget;sa=browse;absolute=' . urlencode($_GET['absolute']) . ';confirm=' . $token;
+			
+			return;
+		}
 	}
 	// Minimum required parameter did not exist so dump out.
 	else
@@ -298,7 +310,7 @@
 	// Get default author and email if they exist.
 	if ($listing->exists('default-author'))
 	{
-		$default_author = $listing->fetch('default-author');
+		$default_author = htmlspecialchars($listing->fetch('default-author'));
 		if ($listing->exists('default-author/@email'))
 			$default_email = $listing->fetch('default-author/@email');
 	}
@@ -308,7 +320,7 @@
 	{
 		$default_website = $listing->fetch('default-website');
 		if ($listing->exists('default-website/@title'))
-			$default_title = $listing->fetch('default-website/@title');
+			$default_title = htmlspecialchars($listing->fetch('default-website/@title'));
 	}
 
 	$the_version = strtr($forum_version, array('SMF ' => ''));
@@ -328,7 +340,7 @@
 
 			// It's a Title, Heading, Rule or Text.
 			if (in_array($package['type'], array('title', 'heading', 'text', 'rule')))
-				$package['name'] = $thisPackage->fetch('.');
+				$package['name'] = htmlspecialchars($thisPackage->fetch('.'));
 			// It's a Remote link.
 			elseif ($package['type'] == 'remote')
 			{
@@ -355,7 +367,7 @@
 					$package['href'] = $scripturl . '?action=packageget;sa=browse;absolute=' . $current_url;
 				}
 
-				$package['name'] = $thisPackage->fetch('.');
+				$package['name'] = htmlspecialchars($thisPackage->fetch('.'));
 				$package['link'] = '<a href="' . $package['href'] . '">' . $package['name'] . '</a>';
 			}
 			// It's a package...
@@ -378,6 +390,8 @@
 
 				if ($package['description'] == '')
 					$package['description'] = $txt['pacman8'];
+				else
+					$package['description'] = parse_bbc(preg_replace('~\[[/]?html\]~i', '', htmlspecialchars($package['description'])));				
 
 				$package['is_installed'] = isset($installed_mods[$package['id']]);
 				$package['is_current'] = $package['is_installed'] && ($installed_mods[$package['id']] == $package['version']);
@@ -397,6 +411,7 @@
 				$package['download_conflict'] = !empty($already_exists) && $already_exists['id'] == $package['id'] && $already_exists['version'] != $package['version'];
 
 				$package['href'] = $url . '/' . $package['filename'];
+				$package['name'] = htmlspecialchars($package['name']);
 				$package['link'] = '<a href="' . $package['href'] . '">' . $package['name'] . '</a>';
 				$package['download']['href'] = $scripturl . '?action=packageget;sa=download' . $server_att . ';package=' . $current_url . $package['filename'] . ($package['download_conflict'] ? ';conflict' : '') . ';sesc=' . $context['session_id'];
 				$package['download']['link'] = '<a href="' . $package['download']['href'] . '">' . $package['name'] . '</a>';
@@ -404,12 +419,12 @@
 				if ($thisPackage->exists('author') || isset($default_author))
 				{
 					if ($thisPackage->exists('author/@email'))
-						$package['author']['email'] = $thisPackage->fetch('author/@email');
+						$package['author']['email'] = htmlspecialchars($thisPackage->fetch('author/@email'));
 					elseif (isset($default_email))
 						$package['author']['email'] = $default_email;
 
 					if ($thisPackage->exists('author') && $thisPackage->fetch('author') != '')
-						$package['author']['name'] = $thisPackage->fetch('author');
+						$package['author']['name'] = htmlspecialchars($thisPackage->fetch('author'));
 					else
 						$package['author']['name'] = $default_author;
 
@@ -424,11 +439,11 @@
 				if ($thisPackage->exists('website') || isset($default_website))
 				{
 					if ($thisPackage->exists('website') && $thisPackage->exists('website/@title'))
-						$package['author']['website']['name'] = $thisPackage->fetch('website/@title');
+						$package['author']['website']['name'] = htmlspecialchars($thisPackage->fetch('website/@title'));
 					elseif (isset($default_title))
 						$package['author']['website']['name'] = $default_title;
 					elseif ($thisPackage->exists('website'))
-						$package['author']['website']['name'] = $thisPackage->fetch('website');
+						$package['author']['website']['name'] = htmlspecialchars($thisPackage->fetch('website'));
 					else
 						$package['author']['website']['name'] = $default_website;
 
@@ -561,7 +576,7 @@
 
 	// Done!  Did we get this package automatically?
 	if (preg_match('~^http://[\w_\-]+\.simplemachines\.org/~', $_REQUEST['package']) == 1 && strpos($_REQUEST['package'], 'dlattach') === false && isset($_REQUEST['auto']))
-		redirectexit('action=packages;sa=install;package=' . $package_name);
+		redirectexit('action=packages;sa=install;package=' . $package_name . ';sesc=' . $context['session_id']);
 
 	// You just downloaded a mod from SERVER_NAME_GOES_HERE.
 	$context['package_server'] = $server;
@@ -572,11 +587,11 @@
 		fatal_lang_error('package_cant_download', false);
 
 	if ($context['package']['type'] == 'modification')
-		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . '">[ ' . $txt['package11'] . ' ]</a>';
+		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . ';sesc=' . $context['session_id'] . '">[ ' . $txt['package11'] . ' ]</a>';
 	elseif ($context['package']['type'] == 'avatar')
-		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . '">[ ' . $txt['package12'] . ' ]</a>';
+		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . ';sesc=' . $context['session_id'] . '">[ ' . $txt['package12'] . ' ]</a>';
 	elseif ($context['package']['type'] == 'language')
-		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . '">[ ' . $txt['package13'] . ' ]</a>';
+		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . ';sesc=' . $context['session_id'] . '">[ ' . $txt['package13'] . ' ]</a>';
 	else
 		$context['package']['install']['link'] = '';
 
@@ -633,11 +648,11 @@
 	}
 
 	if ($context['package']['type'] == 'modification')
-		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . '">[ ' . $txt['package11'] . ' ]</a>';
+		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . ';sesc=' . $context['session_id'] . '">[ ' . $txt['package11'] . ' ]</a>';
 	elseif ($context['package']['type'] == 'avatar')
-		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . '">[ ' . $txt['package12'] . ' ]</a>';
+		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . ';sesc=' . $context['session_id'] . '">[ ' . $txt['package12'] . ' ]</a>';
 	elseif ($context['package']['type'] == 'language')
-		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . '">[ ' . $txt['package13'] . ' ]</a>';
+		$context['package']['install']['link'] = '<a href="' . $scripturl . '?action=packages;sa=install;package=' . $context['package']['filename'] . ';sesc=' . $context['session_id'] . '">[ ' . $txt['package13'] . ' ]</a>';
 	else
 		$context['package']['install']['link'] = '';
 
Index: smf/Sources/Packages.php
===================================================================
--- smf/Sources/Packages.php	(revision 1047)
+++ smf/Sources/Packages.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.2                                           *
+* Software Version:           SMF 1.1.10                                          *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -145,8 +145,10 @@
 {
 	global $boarddir, $txt, $context, $scripturl, $sourcedir, $modSettings;
 
+	checkSession('request');
+
 	// You have to specify a file!!
-	if (!isset($_REQUEST['package']) || $_REQUEST['package'] == '')
+	if (empty($_REQUEST['package']) || preg_match('~[^\\w0-9.\\-_]~', $_REQUEST['package']) === 1 || strpos($_REQUEST['package'], '..') !== false)
 		redirectexit('action=packages');
 	$context['filename'] = preg_replace('~[\.]+~', '.', $_REQUEST['package']);
 
@@ -308,7 +310,7 @@
 
 				$context['actions'][] = array(
 					'type' => $txt['package56'],
-					'action' => strtr($action['filename'], array($boarddir => '.')),
+					'action' => htmlspecialchars(strtr($action['filename'], array($boarddir => '.'))),
 					'description' => $txt['package_action_error']
 				);
 			}
@@ -335,14 +337,14 @@
 				elseif ($mod_action['type'] == 'saved')
 					$context['actions'][] = array(
 						'type' => $txt['package56'],
-						'action' => strtr($mod_action['filename'], array($boarddir => '.')),
+						'action' => htmlspecialchars(strtr($mod_action['filename'], array($boarddir => '.'))),
 						'description' => $failed ? $txt['package_action_failure'] : $txt['package_action_success']
 					);
 				elseif ($mod_action['type'] == 'skipping')
 				{
 					$context['actions'][] = array(
 						'type' => $txt['package56'],
-						'action' => strtr($mod_action['filename'], array($boarddir => '.')),
+						'action' => htmlspecialchars(strtr($mod_action['filename'], array($boarddir => '.'))),
 						'description' => $txt['package_action_skipping']
 					);
 				}
@@ -351,14 +353,14 @@
 					$context['has_failure'] = true;
 					$context['actions'][] = array(
 						'type' => $txt['package56'],
-						'action' => strtr($mod_action['filename'], array($boarddir => '.')),
+						'action' => htmlspecialchars(strtr($mod_action['filename'], array($boarddir => '.'))),
 						'description' => $txt['package_action_missing']
 					);
 				}
 				elseif ($mod_action['type'] == 'error')
 					$context['actions'][] = array(
 						'type' => $txt['package56'],
-						'action' => strtr($mod_action['filename'], array($boarddir => '.')),
+						'action' => htmlspecialchars(strtr($mod_action['filename'], array($boarddir => '.'))),
 						'description' => $txt['package_action_error']
 					);
 			}
@@ -369,27 +371,27 @@
 		elseif ($action['type'] == 'code')
 			$thisAction = array(
 				'type' => $txt['package57'],
-				'action' => $action['filename']
+				'action' => htmlspecialchars($action['filename'])
 			);
 		elseif (in_array($action['type'], array('create-dir', 'create-file')))
 			$thisAction = array(
 				'type' => $txt['package50'] . ' ' . ($action['type'] == 'create-dir' ? $txt['package55'] : $txt['package54']),
-				'action' => strtr($action['destination'], array($boarddir => '.'))
+				'action' => htmlspecialchars(strtr($action['destination'], array($boarddir => '.')))
 			);
 		elseif (in_array($action['type'], array('require-dir', 'require-file')))
 			$thisAction = array(
 				'type' => $txt['package53'] . ' ' . ($action['type'] == 'require-dir' ? $txt['package55'] : $txt['package54']),
-				'action' => strtr($action['destination'], array($boarddir => '.'))
+				'action' => htmlspecialchars(strtr($action['destination'], array($boarddir => '.')))
 			);
 		elseif (in_array($action['type'], array('move-dir', 'move-file')))
 			$thisAction = array(
 				'type' => $txt['package51'] . ' ' . ($action['type'] == 'move-dir' ? $txt['package55'] : $txt['package54']),
-				'action' => strtr($action['source'], array($boarddir => '.')) . ' => ' . strtr($action['destination'], array($boarddir => '.'))
+				'action' => htmlspecialchars(strtr($action['source'], array($boarddir => '.'))) . ' => ' . htmlspecialchars(strtr($action['destination'], array($boarddir => '.')))
 			);
 		elseif (in_array($action['type'], array('remove-dir', 'remove-file')))
 			$thisAction = array(
 				'type' => $txt['package52'] . ' ' . ($action['type'] == 'remove-dir' ? $txt['package55'] : $txt['package54']),
-				'action' => strtr($action['filename'], array($boarddir => '.'))
+				'action' => htmlspecialchars(strtr($action['filename'], array($boarddir => '.')))
 			);
 
 		if (empty($thisAction))
@@ -416,8 +418,10 @@
 {
 	global $boarddir, $txt, $context, $boardurl, $scripturl, $sourcedir, $modSettings;
 
+	checkSession('post');
+
 	// If there's no file, what are we installing?
-	if (!isset($_REQUEST['package']) || $_REQUEST['package'] == '')
+	if (empty($_REQUEST['package']) || preg_match('~[^\\w0-9.\\-_]~', $_REQUEST['package']) === 1 || strpos($_REQUEST['package'], '..') !== false)
 		redirectexit('action=packages');
 	$context['filename'] = $_REQUEST['package'];
 
@@ -609,7 +613,7 @@
 	require_once($sourcedir . '/Subs-Package.php');
 
 	// No package?  Show him or her the door.
-	if (!isset($_REQUEST['package']) || $_REQUEST['package'] == '')
+	if (empty($_REQUEST['package']) || preg_match('~[^\\w0-9.\\-_]~', $_REQUEST['package']) === 1 || strpos($_REQUEST['package'], '..') !== false)
 		redirectexit('action=packages');
 
 	$context['linktree'][] = array(
@@ -634,10 +638,12 @@
 {
 	global $txt, $scripturl, $boarddir, $context, $sourcedir;
 
+	checkSession('get');
+
 	require_once($sourcedir . '/Subs-Package.php');
 
 	// No package?  Show him or her the door.
-	if (!isset($_REQUEST['package']) || $_REQUEST['package'] == '')
+	if (empty($_REQUEST['package']) || preg_match('~[^\\w0-9.\\-_]~', $_REQUEST['package']) === 1 || strpos($_REQUEST['package'], '..') !== false)
 		redirectexit('action=packages');
 
 	// No file?  Show him or her the door.
@@ -670,7 +676,7 @@
 
 	// Let the unpacker do the work.... but make sure we handle images properly.
 	if (in_array(strtolower(strrchr($_REQUEST['file'], '.')), array('.bmp', '.gif', '.jpeg', '.jpg', '.png')))
-		$context['filedata'] = '<img src="' . $scripturl . '?action=packages;sa=examine;package=' . $_REQUEST['package'] . ';file=' . $_REQUEST['file'] . ';raw" alt="' . $_REQUEST['file'] . '" />';
+		$context['filedata'] = '<img src="' . $scripturl . '?action=packages;sa=examine;package=' . $_REQUEST['package'] . ';file=' . $_REQUEST['file'] . ';raw;sesc=' . $context['session_id'] . '" alt="' . $_REQUEST['file'] . '" />';
 	else
 	{
 		if (is_file($boarddir . '/Packages/' . $_REQUEST['package']))
@@ -705,6 +711,8 @@
 {
 	global $boarddir, $sourcedir;
 
+	checkSession('get');
+
 	include_once($sourcedir . '/Subs-Package.php');
 
 	// Open the file and write nothing to it.
@@ -718,6 +726,8 @@
 {
 	global $scripturl, $boarddir;
 
+	checkSession('get');
+
 	// Ack, don't allow deletion of arbitrary files here, could become a security hole somehow!
 	if (!isset($_GET['package']) || $_GET['package'] == 'index.php' || $_GET['package'] == 'installed.list')
 		redirectexit('action=packages;sa=browse');
Index: smf/Sources/PersonalMessage.php
===================================================================
--- smf/Sources/PersonalMessage.php	(revision 1047)
+++ smf/Sources/PersonalMessage.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.10                                          *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -1254,7 +1254,7 @@
 	if ($context['visual_verification'])
 	{
 		$context['use_graphic_library'] = in_array('gd', get_loaded_extensions());
-		$context['verificiation_image_href'] = $scripturl . '?action=verificationcode;rand=' . md5(rand());
+		$context['verificiation_image_href'] = $scripturl . '?action=verificationcode;rand=' . md5(mt_rand());
 
 		// Skip I, J, L, O, Q, S and Z.
 		$character_range = array_merge(range('A', 'H'), array('K', 'M', 'N', 'P'), range('R', 'Z'));
@@ -1345,6 +1345,10 @@
 	);
 	foreach ($error_types as $error_type)
 	{
+		// There is no compatible language string. So lets work around that.
+		if ($error_type == 'wrong_verification_code')
+			$txt['error_wrong_verification_code'] = $txt['visual_verification_failed'];
+
 		$context['post_error'][$error_type] = true;
 		if (isset($txt['error_' . $error_type]))
 			$context['post_error']['messages'][] = $txt['error_' . $error_type];
@@ -1355,7 +1359,7 @@
 	if ($context['visual_verification'])
 	{
 		$context['use_graphic_library'] = in_array('gd', get_loaded_extensions());
-		$context['verificiation_image_href'] = $scripturl . '?action=verificationcode;rand=' . md5(rand());
+		$context['verificiation_image_href'] = $scripturl . '?action=verificationcode;rand=' . md5(mt_rand());
 	}
 
 	// No check for the previous submission is needed.
Index: smf/Sources/Post.php
===================================================================
--- smf/Sources/Post.php	(revision 1047)
+++ smf/Sources/Post.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.10                                          *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -144,6 +144,20 @@
 		$context['preview_subject'] = '';
 	}
 
+	// No message is complete without a topic.
+	if (empty($topic) && !empty($_REQUEST['msg']))
+	{
+		$request = db_query("
+			SELECT id_topic
+			FROM {$db_prefix}messages
+			WHERE id_msg = " . (int) $_REQUEST['msg'], __FILE__, __LINE__);
+		if (mysql_num_rows($request) != 1)
+			unset($_REQUEST['msg'], $_POST['msg'], $_GET['msg']);
+		else
+			list($topic) = mysql_fetch_row($request);
+		mysql_free_result($request);
+	}
+
 	// Check if it's locked.  It isn't locked if no topic is specified.
 	if (!empty($topic))
 	{
@@ -570,8 +584,46 @@
 		$context['submit_label'] = isset($_REQUEST['msg']) ? $txt[10] : $txt[105];
 
 		// Previewing an edit?
-		if (isset($_REQUEST['msg']))
+		if (isset($_REQUEST['msg']) && !empty($topic))
 		{
+			// Get the existing message.
+			$request = db_query("
+				SELECT
+					m.ID_MEMBER, m.modifiedTime, m.smileysEnabled, m.body,
+					m.posterName, m.posterEmail, m.subject, m.icon,
+					IFNULL(a.size, -1) AS filesize, a.filename, a.ID_ATTACH,
+					t.ID_MEMBER_STARTED AS ID_MEMBER_POSTER, m.posterTime
+				FROM ({$db_prefix}messages AS m, {$db_prefix}topics AS t)
+					LEFT JOIN {$db_prefix}attachments AS a ON (a.ID_MSG = m.ID_MSG AND a.attachmentType = 0)
+				WHERE m.ID_MSG = " . (int) $_REQUEST['msg'] . "
+					AND m.ID_TOPIC = $topic
+					AND t.ID_TOPIC = $topic", __FILE__, __LINE__);
+			// The message they were trying to edit was most likely deleted.
+			// !!! Change this error message?
+			if (mysql_num_rows($request) == 0)
+				fatal_lang_error('smf232', false);
+			$row = mysql_fetch_assoc($request);
+	
+			$attachment_stuff = array($row);
+			while ($row2 = mysql_fetch_assoc($request))
+				$attachment_stuff[] = $row2;
+			mysql_free_result($request);
+
+			if ($row['ID_MEMBER'] == $ID_MEMBER && !allowedTo('modify_any'))
+			{
+				// Give an extra five minutes over the disable time threshold, so they can type.
+				if (!empty($modSettings['edit_disable_time']) && $row['posterTime'] + ($modSettings['edit_disable_time'] + 5) * 60 < time())
+					fatal_lang_error('modify_post_time_passed', false);
+				elseif ($row['ID_MEMBER_POSTER'] == $ID_MEMBER && !allowedTo('modify_own'))
+					isAllowedTo('modify_replies');
+				else
+					isAllowedTo('modify_own');
+			}
+			elseif ($row['ID_MEMBER_POSTER'] == $ID_MEMBER && !allowedTo('modify_any'))
+				isAllowedTo('modify_replies');
+			else
+				isAllowedTo('modify_any');
+
 			if (!empty($modSettings['attachmentEnable']))
 			{
 				$request = db_query("
@@ -615,7 +667,7 @@
 		checkSubmitOnce('free');
 	}
 	// Editing a message...
-	elseif (isset($_REQUEST['msg']))
+	elseif (isset($_REQUEST['msg']) && !empty($topic))
 	{
 		checkSession('get');
 
@@ -814,7 +866,7 @@
 				$total_size += filesize($modSettings['attachmentUploadDir'] . '/' . $attachID);
 
 				$context['current_attachments'][] = array(
-					'name' => getAttachmentFilename($name, false, true),
+					'name' => $name,
 					'id' => $attachID
 				);
 			}
@@ -1157,6 +1209,9 @@
 	// Posting a new topic.
 	elseif (empty($topic))
 	{
+		// Now don't be silly, new topics will get their own id_msg soon enough.
+		unset($_REQUEST['msg'], $_POST['msg'], $_GET['msg']);
+
 		if (!isset($_REQUEST['poll']) || $modSettings['pollMode'] != '1')
 			isAllowedTo('post_new');
 
